/* 
 * shellserver (C) 1999 Andrew J. Kroll (GPL) See file COPYING
 
			     ______________
			    /\            /\ 
			   /  \  modems  /  \
			  /    \        /    \
			 / pppd \__on__/ wrap \ 
			 \      /      \      /
			  \    /        \    /
			   \  / networks \  /
			    \/____________\/


Special thanks to Alan Cox for explaining tty/pty's and how they
interconnect, as well as a few of his code snippits...
(of which I shamelessly stole.)


 */

#define TRUE     1
#define FALSE    0

#define PORT 6969

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <signal.h>
#include <errno.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <sys/ioctl.h>
#include <netdb.h>
#include <fcntl.h>
#include <sys/file.h>
#include <arpa/inet.h>
#include <time.h>
#include <termios.h>

#ifdef UNIX98_YUCK
#include <bits/stropts.h>

#endif


#ifdef UNIX98_YUCK
#include <bits/stropts.h>

#endif



#define TERMIO termios
#include <termios.h>

#include <arpa/telnet.h>

struct TERMIO tty_old, tty_new;

#ifdef HPUX
#include <strings.h>
#endif

#define TELOPTS
#include <arpa/telnet.h>

#ifdef UNIX98_YUCK
#include <bits/stropts.h>

#endif


struct progmode {
	unsigned short int passall;
	unsigned short int forked;
	unsigned short int recog;
	unsigned short int passflag;
	unsigned short int progmode;
	unsigned short int control;
};

char commands[10240],arguement[10240];
struct sockaddr_in server;
int outflag=0,inflag=0;
pid_t child=0,leader=0;

int fdPTY,fdTTY;
struct progmode pm;
time_t start;

int a,b,c,d;
int sock, sockr;
char greeting[1024]; /* should be more than enough */
char copybuf[1024]; /* should be more than enough */
int flag=1;
long foo;
struct sockaddr_in srv_addy;
struct sockaddr_in clt_addy;
unsigned int client_len;
struct timeval tout;
struct timeval mydelay;
fd_set rd;
fd_set td;
int nodetach;
int updatend, ndupdated;
time_t ndctime;
int oops=0;

int tty;

#define BUFSIZE 2048

#ifdef DEBUG
FILE *foo;
#endif

#include "common.h"

void killkid(void)
{
	pid_t me;
	int try=0;
	
	me=getpid();
	if(child!=me && child) {
		kill(child,1);
		sleep(5);
		while(kill(child,0)!=-1 && try++<5) {
			kill(child,1);
			sleep(2);
		}
		try=0;
		while(kill(child,0)!=-1 && try++<5) {
			kill(child,15);
			sleep(2);
		}
		try=0;
		while(kill(child,0)!=-1 && try++<5) {
			kill(child,9);
			sleep(2);
		}
	}
	pm.forked = 0;
	if(child==me) exit(0);
}


void normalclose(void)
{
	time_t logtime;
	if(sock>0) { 
		shutdown(sock,0); close(sock);
		sock=-1;
		time(&logtime);
		printf("[%s] Connection from %i.%i.%i.%i. *CLOSED*\n",strpn(ctime(&logtime)),a,b,c,d);
		fflush(stdout);
	}
	if(pm.forked) killkid();
	close(fdPTY);
	close(fdTTY);
}

void fireman(void) {
	union wait status;
	while(wait3(&status,WNOHANG,(struct rusage *)NULL)>0);
	printf("Child process terminated - executed for %lu seconds\r\n",
		(unsigned long int)time(NULL)-start);
	if(pm.forked) killkid();
	normalclose();
}


void problemo(char *string)
{
	pid_t me;
	int try=0;
	time_t logtime;
	
	me=getpid();
	if(sock) close(sock);
	if(child!=me && child) {
		kill(child,1);
		sleep(5);
		while(kill(child,0)!=-1 && try++<5) {
			kill(child,1);
			sleep(2);
		}
		try=0;
		while(kill(child,0)!=-1 && try++<5) {
			kill(child,15);
			sleep(2);
		}
		try=0;
		while(kill(child,0)!=-1 && try++<5) {
			kill(child,9);
			sleep(2);
		}

	}
	if(child!=me) {
		time(&logtime);
		printf("[%s] %s\n",strpn(ctime(&logtime)),string);
		fflush(stdout);
		fflush(stdout);
	}
	exit(0);
}




void cclosed() {
  problemo("Connection closed by foreign host.");
#ifdef DEBUG
  fclose(foo);
#endif

}


#include "snag.h"

unsigned long int resolver(host)
char *host;
{
	int x=0;
	struct hostent *he;

	if(sscanf(host,"%d.%d.%d.%d",&x,&x,&x,&x)==4 || !strcmp(host,"0"))
		return(inet_addr(host));
	while(!(he=gethostbyname((char *)host)) && x++<3)
		sleep(1);
	if(x<3)
		return(htonl((unsigned long int)((unsigned char)he->h_addr_list[0][0]*
			(unsigned int)256+(unsigned char)he->h_addr_list[0][1])*
			(unsigned int)65536+(unsigned long int)((unsigned char)
			he->h_addr_list[0][2]*(unsigned int)256+(unsigned char)
			he->h_addr_list[0][3])));

	problemo("Unable to resolve host name.");
	return -1;
}

int mypopen(int *pty,int *tty,char *arguments)
{

/* this gives a pedantic error, anyone really care to clean this one up? */

	char *argp[] = { "/bin/bash", "-c", NULL, NULL };
	argp[2]=arguments;

#ifdef DEBUG
	fprintf(stderr,"/bin/bash -c %s\r\n", argp[2]);
#endif
 /* the tty side you stick pppd on the pty side you read/write */
	time(&start);
	if (snagpty(pty,tty) == -1)  problemo("Owch! can't get a pty!");

	if((child=fork()) < 0) problemo("Owch! can't fork!");
	if(child) {
		/* parent */
#ifdef DEBUG
		fprintf(stderr,"PID %i Forked\r\n",child);
#endif
		return(child);
	} else {
		/* child */
		setsid();
		child=getpid();
		dup2(*tty,0);
		dup2(*tty,1);
		dup2(*tty,2);

		execve("/bin/sh", argp, NULL);
		_exit(127);
	}
}

void fsock(char *cline)
{
	child=mypopen(&fdPTY,&fdTTY,cline);

	if(child==-1) {
		problemo("[UNABLE TO FORK LOCAL PROGRAM]");
	} else {
		pm.forked=1;
	}
}

void initsocks(int argc,char *argv[])
{
	mydelay.tv_sec = 0;
	mydelay.tv_usec = 50000;
	tout.tv_sec=30;
	tout.tv_usec=0;
	client_len=sizeof(struct sockaddr_in);
	
	
	sockr=socket(AF_INET, SOCK_STREAM, 0);
	bzero ((char *) &srv_addy.sin_addr.s_addr, sizeof(srv_addy.sin_addr.s_addr));
	srv_addy.sin_family=AF_INET;
	srv_addy.sin_port=htons((argc>=2 && atoi(argv[1])>0) ? atoi(argv[1]) : PORT);
	/* this should just wait... */
	{
		time_t logtime;
		time(&logtime);
		printf("[%s] Waiting for socket...", strpn(ctime(&logtime)));
		if (!nodetach) printf("\n");
	}
	setsockopt(sockr, SOL_SOCKET, SO_REUSEADDR, &flag, sizeof(int));
	while(bind(sockr, (struct sockaddr *)&srv_addy, sizeof(srv_addy))<0) {
		if (nodetach) printf(".");
		sleep(2);
	} /* try to bind to address infinitely */
	if (nodetach) printf("\n");
	{
		time_t logtime;
		time(&logtime);
		printf("[%s] Got it!\n", strpn(ctime(&logtime)));
	}
	listen(sockr, 1);
}

void fuckoff(void)
{
	time_t logtime;
	sprintf(greeting,
		"Your hack attempt from IP %i.%i.%i.%i has been logged,\nhave a nice day assmunch! NOT! :-)\n",
		a,b,c,d);
	write(sock,greeting,strlen(greeting));
	time(&logtime);
	printf("[%s] ***WARNING*** Possible HACKER @ %i.%i.%i.%i\n", strpn(ctime(&logtime)),a,b,c,d);
}


void process(void)
{
/* #define MAXIO 2048 */
	char ch[MAXIO];
	int dsize;
	int ret;

	/* open the shell command */
	fsock(commands);
	do {
		sleep(1);
	} while(!pm.forked);
	sprintf(ch,"Executing ` %s`",commands);
	do { 
		ret = write(sock,ch,strlen(ch));
	} while( ret == -1 && errno==EINTR);

	/* say ready, start pipe abuse */
	do {
		ret = write(sock,"\r\n\r\n",4);
	} while( ret == -1 && errno==EINTR);

	do { 
		ret = write(sock,TOOLVER,strlen(TOOLVER));
	} while( ret == -1 && errno==EINTR);
	
	do {
		ret = write(sock,"\r\n\r\nReady.\r\n\r\n",14);
	} while( ret == -1 && errno==EINTR);
	/* start suck loop */
	for (;;) {
		if(pm.forked) {
			FD_ZERO(&rd); FD_SET(sock,&rd); FD_SET(fdPTY,&rd);
			(void) select(32,&rd,0,0,0);
			ch[0]=0x00;
			/* sock -> shell */
			if(pm.forked && (sock>-1)) {
				if(FD_ISSET(sock,&rd)) {
					dsize=read(sock,(void *) &ch, MAXIO);
					if (dsize == 0) return; /* socket lost */
					do { 
						if(!pm.forked || !(sock>-1)) return;
						ret = write(fdPTY,&ch, dsize); 
					} while( ret == -1 && errno==EINTR);
				}
			}
			ch[0]=0x00;
			/* shell -> sock */
			if(pm.forked && (sock>-1)) {
				if (FD_ISSET(fdPTY, &rd)) {
					dsize=read(fdPTY,(void *) &ch, MAXIO);
					if (dsize == 0) return; /* carrier lost */
					do { 
						if(!pm.forked || !(sock>-1)) return;
						ret = write(sock,&ch,dsize); 
					} while( ret == -1 && errno==EINTR);
				}
			}
		}
		if(!pm.forked || !(sock>-1)) return; /* bail if it died */
	}
}


void accep(void)
{
	time_t logtime;

	for(sock=-1;sock<0;) {
		sock=accept(sockr, (struct sockaddr *)&clt_addy,(int *)&client_len);
		if(sock > 0) {
			d=clt_addy.sin_addr.s_addr >> 24 & 255;
			c=clt_addy.sin_addr.s_addr >> 16 & 255;
			b=clt_addy.sin_addr.s_addr >> 8 & 255; 
			a=clt_addy.sin_addr.s_addr & 255; 
			foo=clt_addy.sin_addr.s_addr;
			setsockopt(sock,SOL_TCP,TCP_NODELAY,&flag, sizeof(int));
			time(&logtime);
			sprintf(greeting,"Your IP is %i.%i.%i.%i\n",a,b,c,d); 
			write(sock,greeting,strlen(greeting));
			printf("[%s] SHELLSRV connection from %i.%i.%i.%i\n",strpn(ctime(&logtime)),a,b,c,d);
		}
	}
}
 
int main(int argc,char *argv[])
{
	char commands[10240];
	/* struct timeval ttime; */
	int i;
	pm.passall=pm.forked=pm.recog=inflag=pm.passflag=outflag=pm.control=0;

	if(argc<2 ) {
		sprintf(commands,"\r\n%s\r\nUsage: %s port [command junk]",TOOLVER,argv[0]);
		problemo(commands);
	}	
	commands[0]=0;
	for(i=2; i<argc;i++) {
		sprintf(arguement,"%s ",argv[i]);
		strcat(commands, arguement);
	}

#ifdef DEBUG
	foo = fopen("blah", "a");
#endif


	setvbuf(stdin,NULL,_IONBF,0);
	setvbuf(stdout,NULL,_IONBF,0);

	sock=-1;
	initsocks(argc,argv);			/* bind port */

	for(;;) {
		sock=-1;
		signal(SIGPIPE,(__sighandler_t)fireman);
		signal(SIGCHLD,(__sighandler_t)fireman);
		signal(SIGHUP,(__sighandler_t)fireman);
		signal(SIGINT,(__sighandler_t)cclosed);
		signal(SIGQUIT,(__sighandler_t)cclosed);
		signal(SIGKILL,(__sighandler_t)cclosed);
		accep();			/* wait for request */
		if(sock>0) { 			/* stupid, but it may help */
			process();		/* process connection */
			normalclose();		/* close connection, if still exists, and try again */
		}
	}
	/* never reached, this is here to shut up gcc, course
	   it would be nice if gcc on LinuxNET would shut up sometimes... :-)
	   /me ducks
	*/
	exit(0);
}
