/*
 * pppdwrap (C) 1999 Andrew J. Kroll (GPL) See file COPYING
 
 
			     ______________
			    /\            /\ 
			   /  \  modems  /  \
			  /    \        /    \
			 / pppd \__on__/ wrap \ 
			 \      /      \      /
			  \    /        \    /
			   \  / networks \  /
			    \/____________\/


Special thanks to Alan Cox for explaining tty/pty's and how they
interconnect, as well as a few of his code snippits...
(of which I shamelessly stole.)

*/

int set_termios(int fd, int baud)
{
	struct termios ts;
	switch(baud)
	{
		case  1200:	baud=B1200;	break;
		case  4800:	baud=B4800;	break;
		case  9600:	baud=B9600;	break;
		case 19200:	baud=B19200;	break;
		case 38400:	baud=B38400;	break;
		default:
			problemo("set_termios: shity baud");
			return -1;
	}
	if(tcgetattr(fd,&ts))
	{
	problemo("set_termios: tty can't get attribs. shit!");
		return -1;
	}
	ts.c_iflag=IGNBRK;
	ts.c_oflag=0;
	ts.c_cflag&=~(CBAUD|PARENB|HUPCL|CSIZE|CRTSCTS);
#ifdef THIS_IS_TERMSERVER
	ts.c_cflag|=HUPCL|IGNBRK|IGNPAR|CRTSCTS|CLOCAL|CS8|baud;
#else
	ts.c_cflag|=CLOCAL|CS8|baud;
#endif
	ts.c_lflag=0;
	ts.c_cc[VMIN]=1;
	ts.c_cc[VTIME]=1;
	if(tcsetattr(fd,TCSANOW, &ts))
	{
	problemo("set_termios: tty can't set attribs. shit!");
		return -1;
	}
	return 0;
}




#ifndef THIS_IS_TERMSERVER
static int snagpty(int *pty, int *tty)
{
#ifdef UNIX98_YUCK
	char *name;
	int xpty,xtty;
	xpty = getpt ();
	if (xpty < 0) return -1;

	if (grantpt (xpty) < 0 || unlockpt (xpty) < 0) goto close_pty;
	name = ptsname (xpty);
	if (name == NULL) goto close_pty;

	xtty = open (name, O_RDWR);
	if (xtty == -1) goto close_pty;

	if (isastream (xtty)) {
		if (ioctl (xtty, I_PUSH, "ptem") < 0 || ioctl (xtty, I_PUSH, "ldterm") < 0)
		goto close_tty;
	}


	fcntl(xtty, F_SETFL, 0);
	set_termios(xtty, 38400);
	fcntl(xpty, F_SETFL, 0);
	set_termios(xpty, 38400);
	*pty = xpty;
	*tty = xtty;
	return 0;

	close_tty:
	close (xtty);

	close_pty:
	close (xpty);
	return -1;

#else
	int  pfd,tfd;
	char ttyname[]="/dev/ttyXX"; /* slave */
	char ptyname[]="/dev/ptyXX"; /* master */
	char tmplt1[]="pqrstuvwxyz";
	char tmplt2[]="0123456789abcdef";
	int  tc1,tc2;
	
	for(tc1=0;tc1<11;tc1++)
	{
		for(tc2=0;tc2<16;tc2++)
		{
			ptyname[8]=tmplt1[tc1];
			ptyname[9]=tmplt2[tc2];
			pfd=open(ptyname, O_RDWR|O_NDELAY);
			if(pfd==-1)
				continue;

			ttyname[8]=tmplt1[tc1];
			ttyname[9]=tmplt2[tc2];
			tfd=open(ttyname, O_RDWR|O_NDELAY);
			if(tfd==-1)
			{
				close(pfd);
				continue;
			}
			fcntl(tfd, F_SETFL, 0);	
			set_termios(tfd, 38400);
			*tty=tfd; 

			fcntl(pfd, F_SETFL, 0);
			set_termios(pfd, 38400);
			*pty=pfd;
			return 0;
		}
	}
	return -1;
#endif
}

#endif
